/**
 * Created by Administrator on 2016/1/20.
 */
var stateService = require('./../service/state.js');
var stateBService = require('./../service/stateb.js');
var pageViewService = require('./../service/pageview.js');
var pageViewAllService = require('./../service/pageviewall.js');
var pageViewDetailService = require('./../service/pageviewdetail.js');
var dict = require('../dict/common.js');
var dateutil = require('../modules/dateutil.js');

/**
 * 统计某个时间段的pv等数据, 在某个模式下
 * @param opt findedModel:被查询的model,
 *             savedModel: 被保存数据的model,
 *             validFunc: 模式校验函数 对validedFiled进行处理
 *             validedFiled: 被模式校验的字段
 *             startTime:
 *             endTime:
 * @private
 */
function _statPV(opt) {
    var startTime = opt.startTime;
    var endTime = opt.endTime;
    var urlpathMap = {}; // count, uvCount, ipCount, tokenCount
    var urlpathRecord = {}; // {'m.babamai': {uvMap: { }, ipMap: {}, tokenMap: {} }}
    /*var uvMap = {},
        ipMap = {},
        tokenMap = {};*/
    var selectedFiled = {cuid: 1, ip: 1, token: 1, event: 1};
    selectedFiled[opt.validedFiled] = 1;
    var findedModel = opt.findedModel;
    findedModel.find({
        event: dict.event.init,
        createtime: {$gte: startTime, $lt: endTime}
    }).
    select(selectedFiled).
    exec(function (err, list) {
        if (err) console.err(err);
        console.log('###' + findedModel.modelName + '被处理数据:' + list.length + ', 时间段：' + startTime + '--' + endTime);
        if (list.length === 0) {
            return;
        }

        list.forEach(function (o) {
            var turl = opt.validFunc(o[opt.validedFiled]);
            if (turl && o.event === dict.event.init) {
                _setUrlMap(turl, o);
            }
        });

        var savedModel = opt.savedModel;
        for (var i in urlpathMap) { //多少个需要被统计的url
            //保存数据到pageview
            var o = {};
            o.urlpath = i,
                o.count = urlpathMap[i].count,
                o.uvCount = urlpathMap[i].uvCount,
                o.ipCount = urlpathMap[i].ipCount,
                o.tokenCount = urlpathMap[i].tokenCount,
                o.startTime = startTime,
                o.endTime = endTime;
            savedModel.findOneAndUpdate({
                startTime: startTime,
                endTime: endTime,
                urlpath: i
            }, o, {upsert: true}, function (err, result) {
                if (err) console.err(err);
                console.log('save ' + savedModel.modelName + ' success:' + JSON.stringify(result));
            });
        }
    });


    //设置数据, 数据记录在某个模式下
    function _setUrlMap(turl, o) {
        var tObj = urlpathMap[turl];
        if (tObj) {
            tObj.count++;
        } else {
            tObj = {
                count: 1,
                uvCount: 0,
                ipCount: 0,
                tokenCount: 0
            };
        }

        if(!urlpathRecord[turl]){
            urlpathRecord[turl] = {
                uvMap: {},
                ipMap: {},
                tokenMap: {}
            }
        }
        var targetRecord = urlpathRecord[turl];
        _setValue2('uvMap', o.cuid, 'uvCount');
        _setValue2('ipMap', o.ip, 'ipCount');
        _setValue2('tokenMap', o.token, 'tokenCount');

        urlpathMap[turl] = tObj;

        function _setValue2(m1, k1, k2){
            if(k1 && !targetRecord[m1][k1]){
                tObj[k2]++;
                targetRecord[m1][k1] = 1;
            }
        }
    }
}

/**
 * 把一天以10分钟为一时间段, 进行汇总，处理A表并迁移数据到B表
 * @param targetDate 被统计的那一天的任意日期
 * @param isA 被统计的是否为A表
 */
var statPVByDay = function (targetDate, isA) {
    var startTime = dateutil.getStartAndEndInDay(targetDate).startTime;
    var space = 10; //10分钟为单位
    var timeSpaceNum = 24 * 60 / space; //time时间段
    var spaceMill = space * 60 * 1000;
    var timeArr = []; //时间点数组
    var findedModel = isA ? stateService.model : stateBService.model;
    for (var i = 0; i < timeSpaceNum + 1; i++) {
        timeArr.push(new Date(+startTime + spaceMill * i));
    }
    for (var i = 0, len = timeArr.length - 1; i < len; i++) {
        //statPV(timeArr[i], timeArr[i + 1], i);
        _statPV({
            startTime: timeArr[i],
            endTime: timeArr[i + 1],
            findedModel: findedModel,
            savedModel: pageViewService.model,
            validedFiled: 'project',
            validFunc: function (turl) {
                return turl.replace(/\,.*/, '');
            }
        });
    }
};

/**
 * 统计一天的数据概况, 统计B表
 * @param targetDate
 */
var statAllDataByDay = function (targetDate, isA) {
    var startAndEndDate = dateutil.getStartAndEndInDay(targetDate);
    var findedModel = isA ? stateService.model : stateBService.model;
    _statPV({
        startTime: startAndEndDate.startTime,
        endTime: startAndEndDate.endTime,
        findedModel: findedModel,
        savedModel: pageViewAllService.model,
        validedFiled: 'project',
        validFunc: function (turl) {
            return turl.replace(/\,.*/, '');
        }
    });

    /* var startAndEndDate = dateutil.getStartAndEndInDay(targetDate);
     var startTime = startAndEndDate.startTime;
     var endTime = startAndEndDate.endTime;
     var StateBModel = stateBService.model;
     var urlpathMap = {}; // count, uvCount, ipCount, tokenCount
     var uvMap = {},
     ipMap = {},
     tokenMap = {};

     StateBModel.find({
     url: /.+/,
     event: dict.event.init,
     createtime: {$gte: startTime, $lt: endTime}
     }).
     select({project: 1, cuid: 1, ip: 1, token: 1, event: 1}).
     exec(function (err, list) {
     if (err) console.err(err);
     console.log('###statAll被处理数据:' + list.length + ', 时间段：' + startTime + '--' + endTime);
     if (list.length === 0) {
     return;
     }

     list.forEach(function (o) {
     var turl = _getValidUrl(o.project);
     if (turl && o.event === dict.event.init) {
     _setUrlMap(turl, o);
     }
     });

     for (var i in urlpathMap) { //多少个需要被统计的url
     //保存数据到pageview
     var o = {};
     o.urlpath = i,
     o.count = urlpathMap[i].count,
     o.uvCount = urlpathMap[i].uvCount,
     o.ipCount = urlpathMap[i].ipCount,
     o.tokenCount = urlpathMap[i].tokenCount,
     o.startTime = startTime,
     o.endTime = endTime;
     var PageViewAllModel = pageViewAllService.model;
     PageViewAllModel.findOneAndUpdate({
     startTime: startTime,
     endTime: endTime,
     urlpath: i
     }, o, {upsert: true}, function (err, result) {
     if (err) console.err(err);
     console.log('save pageViewAll success:' + JSON.stringify(result));
     });
     }
     });

     //设置数据
     function _setUrlMap(turl, o) {
     var tObj = urlpathMap[turl];
     if (tObj) {
     tObj.count++;
     } else {
     tObj = {
     count: 1,
     uvCount: 0,
     ipCount: 0,
     tokenCount: 0
     };
     }
     _setValue(uvMap, o.cuid, tObj, 'uvCount');
     _setValue(ipMap, o.ip, tObj, 'ipCount');
     _setValue(tokenMap, o.token, tObj, 'tokenCount');
     urlpathMap[turl] = tObj;
     function _setValue(m1, k1, m2, k2) {
     if (k1 && !m1[k1]) {
     m2[k2]++;
     m1[k1] = 1;
     }
     }
     }*/
};

//_testCount();
/*function _testCount(){
    var startAndEndTime = dateutil.getStartAndEndInDay(new Date());
    var startTime = new Date('2016-01-26 12:10:00.000');
    var endTime = new Date('2016-01-26 12:20:00.000');
    stateBService.model.count({
        project: /^m.babamai/,
        event: dict.event.init,
        createtime: {$gte: startTime, $lt: endTime}
    }, function(err, count){
        if(err) console.err(err);
        console.log('##count:' + count);
    });
}*/

/**
 * 统计一天里所有页面的数据, 通过处理url，处理B表
 */
var statPagePVByDay = function (targetDate, isA) {
    var startAndEndDate = dateutil.getStartAndEndInDay(targetDate);
    var findedModel = isA ? stateService.model : stateBService.model;
    _statPV({
        startTime: startAndEndDate.startTime,
        endTime: startAndEndDate.endTime,
        findedModel: findedModel,
        savedModel: pageViewDetailService.model,
        validedFiled: 'url',
        validFunc: function (turl) {
            turl = turl.replace(/\?.*/, '');
            turl = turl.replace(/(\(|\))/g, '\\$1');
            return turl;
        }
    });
};

module.exports = {
    statPVByDay: statPVByDay,
    statAllDataByDay: statAllDataByDay,
    statPagePVByDay: statPagePVByDay
};

