/**
 * Created by Administrator on 2016/1/15.
 */
;(function(){
    function  isNumber(e){
        return !isNaN(parseFloat(e)) && isFinite(e);
    }
    var cookie = {
        /**
         * @public 设置cookie。setCookie(key, value, expires, path, domain, secure)
         * @method setCookie
         * @param {String} key cookie的键名
         * @param {String} val cookie字段的值
         * @param {Number} [expires] 保存天数
         * @param {String} [domain] cookie域名
         * @param {String} [path] cookie路径
         * @param {Boolean} [secure] cookie是否为安全传输
         * @return void
         */
        set:function(key, val, expires, domain, path, secure){
            if (!path) path = '/';
            if (!isNumber(expires)) expires = 365;
            expires = expires * 86400000;
            var e_date = new Date();
            e_date.setTime(+e_date + expires);
            document.cookie =
                key + '=' + encodeURIComponent(val)
                + (expires ? '; expires=' + e_date.toGMTString() : '')
                + (domain ? '; domain=' + domain : '')
                + (path ? '; path=' + path : '')
                + (secure ? '; secure' : '');
        },

        /**
         * 获取 cookie 值
         * @param {String} key cookie字段的名字
         * @return {String} 如果 key 不存在，返回 null
         */
        get: function(key) {
            var c = document.cookie.split("; ");
            for (var i = 0; i < c.length; i++) {
                var p = c[i].split("=");
                if (key == p[0]) try { return decodeURIComponent(p[1]) } catch (e) { return null }
            }
            return "";
        },

        /**
         * 删除 cookie 值
         * @param {String} key cookie字段的名字
         * @param {String} domain
         * @param {String} path
         */
        remove: function(key, domain, path) {
            document.cookie = key + "=1" + (path ? "; path="+path:"; path=/")+(domain?"; domain="+domain:"")+"; expires=Fri, 02-Jan-1970 00:00:00 GMT";
        },

        /**
         * 获取域名以.分隔的最后两段或三段，
         * m.babamai.com.cn -> .babamai.com.cn
         * m.163.com -> .163.com
         */
        getDomain:function(){
            var reg = /(com|net|org|gov)\.cn$/;
            if(reg.test(location.host)){
                return "." + location.host.split(".").slice(-3).join(".");
            }else{
                return "." + location.host.split(".").slice(-2).join(".");
            }
        }
    };

    var BBM = window["BBM"] || {};
    BBM.cookie = cookie;
    window["BBM"] = BBM;
})();

;(function () {
    function jsonp(url, cb){
        var script = document.createElement('script');
        var funcName = _getFuncName();
        cb && (window[funcName] = cb);
        var str = url + '&callback=' + funcName;
        script.src = str;
        script.onload = function (e) {
            this.onload = null;
            document.head.removeChild(this);
        };
        document.head.appendChild(script);
        function _getFuncName(){
            var r = Math.random() + '';
            var str = '_bbm' + r.substr(2);
            return str;
        }
    }
    var BBM = window["BBM"] || {};
    BBM.jsonp = jsonp;
    window["BBM"] = BBM;
})();

;(function () {
    var cookie = BBM.cookie;
    var jsonp = BBM.jsonp;
    var cacheData = {}; //缓存数据

    var option = {
        cuidField: 'cuid', //cookie中用户id字段名
        dataStateIdField: 'data-stateid',  //元素统计用的id字段名
        remoteHost: 'http://stat.babamai.com.cn',
        //remoteHost: '',
        etype: {
            'process': 'process',
            'action': 'action'
        },
        event: {
            'init': 'init',
            'active': 'active',
            'unload': 'unload',
            'tap': 'tap',
            'click': 'click'
        },
        globalWrapClass: 'bbm-wrap'
    };

    function BBM_STATE() {
        var _this = this;
        function init(d){
            option.cuid = d.cuid;
            window.addEventListener('beforeunload', function(){
                _this.saveUnload();
            });
            func.save();
        }
        var cuid = cookie.get(option.cuidField);
        if(cuid){
            init({cuid: cuid});
        }else{
            var url = option.remoteHost + '/state/createcuid?';
            jsonp(url, cacheCuid);
        }

        function cacheCuid(d){
            var t = d.cuid ? d.cuid : Math.random();
            cookie.set(option.cuidField, t, 10*365, cookie.getDomain());
            init({cuid: t});
        }
    }

    var func = BBM_STATE;
    func.serialize = function (d) {
        var arr = [];
        for (var i in d) {
            arr.push(encodeURIComponent(i) + '=' + encodeURIComponent(d[i]));
        }
        return arr.join('&');
    };
    func.saveData = function (d) {
        var img = null;
        if (window.Image) {
            img = new Image();
        } else {
            img = document.createElement('img');
        }
        img.onload = function (e) {
            img = null;
        };
        img.src =  option.remoteHost + '/state?' + func.serialize(d);
    };
    func.save = function (d) {
        var data = func.getData(d);
        func.saveData(data);
    };
    func.getData = function (opt) {
        var d = {};
        d.project = _getProject(),
            d.url = location.href,
            d.ref = document.referrer,
            d.r = Math.random(),
            d.token = _getLocalStorage('token'),
            d.passport = _getLocalStorage('passport') ,
            d.openid = _getLocalStorage('openId'),
            d.cuid = option.cuid;
            d.etype = option.etype.process,
            d.event = option.event.init,
            d.time = +new Date,
            d.resolution = _getResolution(),
            d.viewsize = _getViewSize(),
            d.pagesize = _getPageSize(),
            d.pagescroll = _getPageScroll(),
            d.ua = navigator.userAgent,
            d.ext1 = _getExt1();
        for (var i in opt) {
            d[i] = opt[i];
        }
        return d;
        /**
         * http://m.babamai.com.cn/mobile/sft_order_yg2.html
         * -> m_babamai,mobile
         * @private
         */
        function _getProject() {
            if(cacheData.project){
                return cacheData.project;
            }
            var host = location.host;
            //var dTop = ['com.cn', 'net.cn', 'org.cn', 'gov.cn'];
            host = host.replace(/^www\./, '');
            host = host.replace(/(com|net|org|gov)\.cn$/, 'xcn');
            //host = host.substring(0, host.lastIndexOf('.'));
            host = host.substring(0, host.lastIndexOf('.'));
            var t1 = [];
            if (host) {
                t1 = host.split('.');
            }
            var pathname = location.pathname;
            pathname = pathname.replace(/^\//, '');
            pathname = pathname.substring(0, pathname.lastIndexOf('/'));
            var t2 = [];
            if (pathname) {
                t2 = pathname.split('/');
            }
            cacheData.project = t1.join('.') + ',' + t2.join('/');
            return cacheData.project;
        }

        function _getLocalStorage(s) {
            var v = localStorage.getItem(s)
            return v ? v : '';
        }

        function _getResolution() {
            return screen.width + '/' + screen.height;
        }

        function _getViewSize() {
            var w = window.innerWidth || document.documentElement.clientWidth,
                h = window.innerHeight || document.documentElement.clientHeight;
            return w + '/' + h;
        }

        function _getPageSize() {
            var target = document.body;
            var tar = document.getElementsByClassName(option.globalWrapClass);
            if (tar.length) {
                target = tar[0];
            }
            return target.offsetWidth + '/' + target.offsetHeight;
        }

        function _getPageScroll() {
            var x = window.scrollX || document.body.scrollLeft || document.documentElement.scrollLeft,
                y = window.scrollY || document.body.scrollTop || document.documentElement.scrollTop;
            return x + '/' + y;
        }

        function _getExt1(){
            var str = '';
            str += 'cookieEnabled=' + navigator.cookieEnabled;
            return str;
        }
    };
    func.getSource = function (i) {
        var source = '';
        if(i instanceof  HTMLElement){
            source = i.getAttribute(option.dataStateIdField);
            if(!source) source = i.className;
        }else if(typeof i === 'string'){
            source = i;
        }
        return source;
    };

    var proto = BBM_STATE.prototype;
    proto.saveTap = function (i) {
        var d = {
            esource: func.getSource(i),
            etype: option.etype.action,
            event: option.event.tap
        }
        func.save(d);
    };
    proto.saveClick = function(i){
        var d = {
            esource: func.getSource(i),
            etype: option.etype.action,
            event: option.event.click
        }
        func.save(d);
    };
    proto.saveUnload = function(){
        func.save({
            eytpe: option.etype.process,
            event: option.event.unload
        });
    };

    if (!window.BBM_STATE) {
        window.BBM_STATE = new BBM_STATE();
    }
})();