/**
 * Created by Administrator on 2016/1/21.
 */
var express = require('express');
var router = express.Router();
var baseRoute = require('./base.js');
var task = require('../analyse/task.js');
var dateutil = require('../modules/dateutil.js');
var taskLogService = require('../service/tasklog.js');

router.get('/', function (req, res, next) {
    res.render('task', {title: '任务'});
});

router.get('/domovedata', function (req, res, next) {
    var d = req.query;
    console.log(JSON.stringify(d));
    d.time = new Date(d.time);
    task.doMoveData(d, function (obj) {
        baseRoute.success.call(res, obj);
    });
});
router.get('/dostatpv', function (req, res, next) {
    var d = req.query;
    console.log(JSON.stringify(d));
    d.time = new Date(d.time);
    task.doStatPV(d, function (obj) {
        baseRoute.success.call(res, obj);
    });
});
router.get('/dostatpvall', function (req, res, next) {
    var d = req.query;
    console.log(JSON.stringify(d));
    d.time = new Date(d.time);
    task.doStatPVAll(d, function (obj) {
        baseRoute.success.call(res, obj);
    });
});
router.get('/dostatpagepv', function (req, res, next) {
    var d = req.query;
    console.log(JSON.stringify(d));
    d.time = new Date(d.time);
    task.doStatPagePVByDay(d, function (obj) {
        baseRoute.success.call(res, obj);
    });
});
router.get('/log', function (req, res, next) {
    var d = req.query;
    var num = parseInt(d.num);
    taskLogService.model.find().limit(num).sort({createTime: -1}).
    exec(function (err, list) {
        if (err) console.error(err);
        var arr = [];
        list.forEach(function (o, i) {
            var o = {
                author: o.author,
                des: o.des,
                sn : i+1,
                targetDate: dateutil.convertTimeToStr(o.time),
                createTimeStr: dateutil.convertTimeToStr(o.createTime)
            };
            arr.push(o);
        });
        baseRoute.success.call(res, arr);
    });
});

module.exports = router;